// Console.cpp: implementation of the Console class.
//
//////////////////////////////////////////////////////////////////////



#include <stdarg.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <string>
#include <memory.h>
#include <dos.h>
#include <math.h>
#include <fcntl.h>
#include <io.h>
#include <sys\types.h>
#include <sys\stat.h>

#include <malloc.h>
#include <float.h>
#include <windows.h>
#include <mmsystem.h>
#include <process.h>
#include <assert.h>
#include <commctrl.h>
#include <commdlg.h>
#include <objbase.h>


#include "Console.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Console::Console()
{
#ifndef FILE

	mHwnd=NULL;

	mHwnd=(long)FindWindow(NULL,"C++ Console");
	if (mHwnd==NULL) MessageBox(0,"The C++ Console was not found.  Console reporting will be lost.","No C++ Console!",MB_OK);
	else 
	{
		COPYDATASTRUCT copy;
		copy.cbData=0;
		copy.lpData=NULL;
		SendMessage((HWND)mHwnd,WM_COPYDATA,NULL,(long)&copy);

		Out("*** BEGIN SESSION ***");
	}

#else
	mHwnd=creat("DEBUG.TXT",S_IREAD|S_IWRITE);close(mHwnd);
	Out("*** BEGIN SESSION ***");
#endif
}

Console::~Console()
{
	Out("*** END SESSION NORMALLY ***");
}

void Console::Out(char *format, ...)
{
#ifndef FILE
	if (mHwnd==NULL) return;

	char *xstring=(char*)GlobalAlloc(GMEM_FIXED,2048);

	va_list argp;
 	va_start(argp, format);
	vsprintf(xstring,format, argp);
	va_end(argp);

	COPYDATASTRUCT copy;
	copy.cbData=strlen(xstring)+1;
	copy.lpData=xstring;

	SendMessage((HWND)mHwnd,WM_COPYDATA,NULL,(long)&copy);

	GlobalFree(xstring);
#else
	mHwnd=open("DEBUG.TXT",O_BINARY|O_RDWR);
	lseek(mHwnd,0,SEEK_END);

	char *xstring=(char*)GlobalAlloc(GMEM_FIXED,2048);

	va_list argp;
 	va_start(argp, format);
	vsprintf(xstring,format, argp);
	va_end(argp);

	char crlf[2]={13,10};

	write(mHwnd,xstring,strlen(xstring));
	write(mHwnd,crlf,2);
	close(mHwnd);
#endif
}

